#include <pspkernel.h>
#include <pspctrl.h>
#include <psppower.h>
#include <systemctrl.h>
#include <systemctrl_se.h>
#include <pspinit.h>
#include <string.h>
#include <kubridge.h>

#include <stdio.h>
#include "conf.h"


PSP_MODULE_INFO("DualBoot", 0x1000, 0, 0);

//pXw
#define PRO_PATH "/PRO.PBP"
#define ME_PATH "/ME.PBP"
#define XE_PATG "XE.PBP"

int main_thread(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);

//GAMEN邽 AutoStart p
void Exec(char *gamepath)
{
	int k1 = pspSdkSetK1(0);
	
	u32 vshmain_args[0x0400/4];
	memset(vshmain_args, 0, sizeof(vshmain_args));
	vshmain_args[0x40] = 1;
	vshmain_args[0x280] = 1;
	vshmain_args[0x284] = 3;
	vshmain_args[0x286] = 5;

	struct SceKernelLoadExecVSHParam param;
	
	memset(&param, 0, sizeof(param));
	param.size = sizeof(param);
	param.args = strlen(gamepath)+1;
	param.argp = gamepath;
	param.key = "game";
	param.vshmain_args_size = sizeof(vshmain_args);
	param.vshmain_args = vshmain_args;
	param.unk4 = 0;
	param.unk5 = 0;


	sctrlKernelLoadExecVSHMs2(gamepath, &param);

	pspSdkSetK1(k1);
}

//pX擾 AutoStart p
void GetPath(char *path, void *argp)
{
	char *temp;

	strcpy(path, argp);
	temp = strrchr(path, '/');
	if( temp != NULL ) *temp = '\0';
}

//C
int main_thread(SceSize args, void *argp)
{
	//Thanks ABCanG.
	while( 1 )
	{
		if(
			sceKernelFindModuleByName("sceSystemMemoryManager") && 
			sceKernelFindModuleByName("sceIOFileManager") && 
			sceKernelFindModuleByName("sceGE_Manager") && 
			sceKernelFindModuleByName("sceDisplay_Service") && 
			sceKernelFindModuleByName("sceController_Service") && 
			sceKernelFindModuleByName("sceKernelLibrary")
		)
		{
			break;
		}
		sceKernelDelayThread(1000);
	}
	
	
	//pX
	char propath[256];
	char mepath[256];
	char xepath[256];
	
	//pX擾
	GetPath(propath,argp);
	GetPath(mepath,argp);
	GetPath(xepath,argp);
	
	//path  PATH 
	strcat(propath, PRO_PATH);
	strcat(mepath, ME_PATH);
	strcat(xepath, XE_PATG);
	
	//pbh͂̂߂
	SceCtrlData pad;
	sceCtrlPeekBufferPositive(&pad, 1);

	sceKernelDelayThread(5000);
	
	//SELECTȂN PRON
	if (pad.Buttons & PSP_CTRL_SELECT){
	Exec(propath);
	}
	
	//STARTȂN MEN
	if (pad.Buttons & PSP_CTRL_START){
	Exec(mepath);
	}
	
	//LȂN TN XtendedN
	if (pad.Buttons & PSP_CTRL_LTRIGGER){
	Exec(xepath);
	}
	
	return 0;
}


int module_start(SceSize args, void *argp)
{

		int thid = sceKernelCreateThread("DualBoot", main_thread, 8, 0x2000, 0, NULL);
		if(thid >= 0)sceKernelStartThread(thid, args, argp);

	return 0;
}


int module_stop(SceSize args, void *argp)
{
	return 0;
}
